using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using TahDoMvc5.Models;

namespace TahDoMvc5.Controllers
{
    public class TahDoItemsController : Controller
    {
        private TahDoMvc5Context db = new TahDoMvc5Context();

        // GET: /TahDoItems/
        public ActionResult Index()
        {
            var tahdoitems = db.TahDoItems.Include(t => t.TahDoList);
            return View(tahdoitems.ToList());
        }

        // GET: /TahDoItems/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TahDoItem tahdoitem = db.TahDoItems.Find(id);
            if (tahdoitem == null)
            {
                return HttpNotFound();
            }
            return View(tahdoitem);
        }

        // GET: /TahDoItems/Create
        public ActionResult Create()
        {
            ViewBag.TahDoListId = new SelectList(db.TahDoLists, "Id", "Title");
            return View();
        }

        // POST: /TahDoItems/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include="Id,Title,CreatedAt,Priority,Note,TahDoListId,Done,DoneAt")] TahDoItem tahdoitem)
        {
            if (ModelState.IsValid)
            {
                db.TahDoItems.Add(tahdoitem);
                db.SaveChanges();
                return RedirectToAction("Index");
            }

            ViewBag.TahDoListId = new SelectList(db.TahDoLists, "Id", "Title", tahdoitem.TahDoListId);
            return View(tahdoitem);
        }

        // GET: /TahDoItems/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TahDoItem tahdoitem = db.TahDoItems.Find(id);
            if (tahdoitem == null)
            {
                return HttpNotFound();
            }
            ViewBag.TahDoListId = new SelectList(db.TahDoLists, "Id", "Title", tahdoitem.TahDoListId);
            return View(tahdoitem);
        }

        // POST: /TahDoItems/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include="Id,Title,CreatedAt,Priority,Note,TahDoListId,Done,DoneAt")] TahDoItem tahdoitem)
        {
            if (ModelState.IsValid)
            {
                db.Entry(tahdoitem).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.TahDoListId = new SelectList(db.TahDoLists, "Id", "Title", tahdoitem.TahDoListId);
            return View(tahdoitem);
        }

        // GET: /TahDoItems/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            TahDoItem tahdoitem = db.TahDoItems.Find(id);
            if (tahdoitem == null)
            {
                return HttpNotFound();
            }
            return View(tahdoitem);
        }

        // POST: /TahDoItems/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            TahDoItem tahdoitem = db.TahDoItems.Find(id);
            db.TahDoItems.Remove(tahdoitem);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}
